/***** BEGIN LICENSE BLOCK *****

    FlashGot - a Firefox extension for external download managers integration
    Copyright (C) 2004-2013 Giorgio Maone - g.maone@informaction.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                             
***** END LICENSE BLOCK *****/

var Youtube = {

  process: function(id, callback, isPrivate) {
    var xhr =  CC["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(CI.nsIXMLHttpRequest);
    xhr.open("GET", "http://www.youtube.com/get_video_info?hl=en_US&el=detailpage&video_id=" + id);
    if (isPrivate) {
      fg.privatize(xhr.channel);
    }
    xhr.addEventListener("readystatechange", function(ev) {
      if (xhr.readyState !== 4) return;
      var data = Youtube.parse(xhr.responseText || "");
      callback (
        ("url_encoded_fmt_stream_map" in data)
        ? { title: data.title, 
            streams: data.url_encoded_fmt_stream_map.split(",").map(Youtube.parse, this) 
          }
        : null
      );
    }, false);
    xhr.send(null);
  },
  parse: function(s) {
    var pairs = s.split("&");
    var res = {};
    var nv;
    for each (var p in pairs) {
      try {
        nv = p.split("=").map(function(v) { return decodeURIComponent(v.replace(/\+/g, ' ')) });
        if (!(nv[0] in res)) res[nv[0]] = nv[1];
      } catch (e) {}
    }
    return res;
  }
};